do
    --- version 2 ---
    ---@class StopwatchTimer
    CallbackTimer = {}

    function CallbackTimer:periodic_tick_callback(time)
        if time - self.start_time >= self.period then
            self.callback()
            self.start_time = time
            self.expired_event:publish(self)
        end
    end


    function CallbackTimer:start_tick_callback(time)
        self.start_time = time
        if self.period == 0 then
            self:periodic_tick_callback(time)
        end
        self.tick_callback = self.periodic_tick_callback
    end

    ---@public
    ---@param cls StopwatchTimer
    ---@return StopwatchTimer
    function CallbackTimer.create(cls, period, callback)
        local obj = {} ---@type StopwatchTimer
        obj = setmetatable(obj, cls.meta)
        obj.period = (period or 0.01) - 0.00001
        --obj.expired_event = table.tools.Observer() ---@type Observer
        --obj.start_time = 0
        --obj.callback = nil --callback
        --obj.tick_callback = obj.start_tick_callback
        callback = nil
        return obj
    end

    CallbackTimer.meta = {
       __index = CallbackTimer,
       __call = function(obj,...) obj:tick_callback(...) end
    }

    setmetatable(CallbackTimer, {
        __call = CallbackTimer.create
    })
end 