do
    table = table or {}
    table.tools = table.tools or {}
    local Observer = table.tools.Observer

    --- version 2 ---
    ---@class Metronome
    Metronome = {}

    ---@public
    function Metronome:start()
        TimerStart(self.timer_handle, self.period, true, self.tick_callback)
        return self
    end
    
    ---@public
    ---@param callback function
    function Metronome:add_tick_event(callback)
        self.tick_event:subscribe(callback)
    end

    ---@public
    ---@param callback function
    function Metronome:remove_tick_event(callback)
        self.tick_event:unsubscribe(callback)
    end

    ---@public
    ---@param cls Metronome
    function Metronome.create(cls, period)
        local obj = setmetatable({}, cls.__meta) ---@type Metronome
        obj.timer_handle = CreateTimer()
        obj.tick_event = Observer() ---@type Observer
        obj.period = period or 0.01
        obj.tick_callback = function()
            obj.tick_event:notify()
        end
        return obj
    end

    Metronome.__meta = {
        __index = Metronome
    }

    setmetatable(Metronome, {
        __call = Metronome.create
    })
end